﻿using Vintasoft.Data;
using Vintasoft.Imaging.Web.Api2Controllers;
using Vintasoft.Imaging.Web.Services;

namespace WebImageViewerDemo_Database.Controllers
{
    /// <summary>
    /// API controller that handles HTTP requests from clients and
    /// allows to get information about image or render image thumbnail/tile.
    /// </summary>
    public class VintasoftDBImageApiController : VintasoftImageApi2Controller
    {

        public VintasoftDBImageApiController()
            : base()
        {
        }



        /// <summary>
        /// Creates the <see cref="VintasoftImageWebService"/>.
        /// that handles HTTP requests from clients and allows to process an image.
        /// </summary>
        /// <param name="sessionId">Session ID.</param>
        /// <returns>
        /// The <see cref="VintasoftImageWebService"/>.
        /// that handles HTTP requests from clients and allows to process an image.
        /// </returns>
        protected override VintasoftImageWebService CreateWebService(string sessionId)
        {
            IDataStorage storage = new DataBaseImageStorage();
            return new VintasoftImageWebService(storage);
        }

    }
}
