﻿using System;
using System.IO;
using Vintasoft.Data;

namespace WebImageViewerDemo_Database
{
    /// <summary>
    /// Storage that allows to store data in database.
    /// </summary>
    /// <remarks>
    /// Current data storage works in read-only mode.
    /// </remarks>
    public class DataBaseImageStorage : IDataStorage
    {

        public void AddItem(string key, object item)
        {
            throw new Exception("Service work in read-only mode.");
        }

        public bool CanStore(Type type)
        {
            if (typeof(Stream).IsAssignableFrom(type))
                return true;
            else
                return false;
        }

        public bool Contains(string key)
        {
            return key == "0" || key == "1";
        }

        public void DeleteItem(string key)
        {
            throw new Exception("Service work in read-only mode.");
        }

        public object GetItemCopy(string key)
        {
            if (Contains(key))
            {
                 // get file name
                string filename = key == "0" ? "AllSupportedBarcodes.png" : "web-annotations.tif";
                // get file path
                string filePath = System.Web.Hosting.HostingEnvironment.MapPath(string.Format("/Images/{0}", filename));
                FileStream fs = new FileStream(filePath, FileMode.Open, FileAccess.Read, FileShare.None);
                return fs;
            }
            else
                throw new Exception(string.Format("File \"{0}\" does not exist.", key));
        }

        public string[] GetKeys()
        {
            return new string[2] { "0", "1" };
        }

        public object LockItem(string key)
        {
            throw new Exception("Service work in read-only mode.");
        }

        public void SetItem(string key, object item)
        {
            throw new Exception("Service work in read-only mode.");
        }

        public void UnlockItem(string key, object item)
        {
            throw new Exception("Service work in read-only mode.");
        }

        public void Dispose()
        {
            
        }
    }
}